Index: arch/arm/mach-ep93xx/mm.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mach-ep93xx/mm.c,v
retrieving revision 1.1
retrieving revision 1.13
diff -u -r1.1 -r1.13
--- arch/arm/mach-ep93xx/mm.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/arm/mach-ep93xx/mm.c	24 Jan 2007 00:36:06 -0000	1.13
@@ -41,7 +41,6 @@
  *  8080 0000 - 809f ffff = APB peripherals  (2 Meg)
  *  8900 0000 - 82ff ffff = TS-7XXX 8bit isa io/mem
  *  8b00 0000 - 86ff ffff = TS-7XXX 16bit isa io/mem
- *  a000 0000 - b000 0000 = PCMCIA space
  */ 
 static struct map_desc ep93xx_io_desc[] __initdata = 
 {
@@ -49,23 +48,24 @@
     // Virtual Address                Physical Addresss    Size in Bytes  Domain     R  W  C  B Last
     { IO_ADDRESS(EP93XX_AHB_BASE),    EP93XX_AHB_BASE,         SZ_8M    , DOMAIN_IO, 0, 1, 0, 0 },
     { IO_ADDRESS(EP93XX_APB_BASE),    EP93XX_APB_BASE,         SZ_2M    , DOMAIN_IO, 0, 1, 0, 0 },
-    { PCMCIA_BASE_VIRT,               PCMCIA_BASE_PHYS,     PCMCIA_SIZE , DOMAIN_IO, 0, 1, 0, 0 },
-    { IO_ADDRESS(TS7XXX_IO8_BASE),    TS7XXX_IO8_BASE_PHYS,     SZ_32M , DOMAIN_IO, 0, 1, 0, 0 },
-    { IO_ADDRESS(TS7XXX_IO16_BASE),   TS7XXX_IO16_BASE_PHYS,    SZ_32M , DOMAIN_IO, 0, 1, 0, 0 },
-    { IO_ADDRESS(TS7XXX_FLASH_BASE),  TS7XXX_FLASH_BASE_PHYS,   SZ_16M , DOMAIN_IO, 0, 1, 0, 0 },
+    { IO_ADDRESS(TS7XXX_IO8_BASE),    TS7XXX_IO8_BASE_PHYS,     SZ_64M , DOMAIN_IO, 0, 1, 0, 0 },
+    { IO_ADDRESS(TS7XXX_IO16_BASE),   TS7XXX_IO16_BASE_PHYS,    SZ_64M , DOMAIN_IO, 0, 1, 0, 0 },
+    { IO_ADDRESS(TS7XXX_FLASH_BASE),  TS7XXX_FLASH_BASE_PHYS,   SZ_16M, DOMAIN_IO, 0, 1, 0, 0 },
+    { IO_ADDRESS(TS7XXX_FLASH2_BASE),  TS7XXX_FLASH2_BASE_PHYS,   SZ_16M, DOMAIN_IO, 0, 1, 0, 0 },
+    { IO_ADDRESS(TS7XXX_FLASH3_BASE),  TS7XXX_FLASH3_BASE_PHYS,   SZ_16M, DOMAIN_IO, 0, 1, 0, 0 },
     LAST_DESC
 };
 
 void __init ep93xx_map_io(void)
 {
-	unsigned int *smc;
+	extern int console_loglevel;
+	unsigned char stat;
 
 	iotable_init(ep93xx_io_desc);
-
-	smc = IO_ADDRESS(SMCBCR1);
-	*smc = 0x0000ffef;
-	smc = IO_ADDRESS(SMCBCR2);
-	*smc = 0x1000ffef;
-//	smc = IO_ADDRESS(SMCBCR6);
-//	*smc = 0x18002122;
+//	stat = inb(TS7XXX_STATUS);
+//	if ((stat & 0x1) != 0x1) console_loglevel = 4;
+	if (!inb(TS7XXX_STATUS2) & 0x4) outw(0x4, TS7XXX_ENIO);
+	outw(0x5, TS7XXX_WATCHDOG_FEED);
+	outw(0x0, TS7XXX_WATCHDOG_CTRL);
+	outl(0x20000000, SYSCON_PWRCNT);
 }
Index: arch/arm/mach-integrator/cpu.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mach-integrator/cpu.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mach-integrator/cpu.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/arm/mach-integrator/cpu.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -3,7 +3,7 @@
  *
  *  Copyright (C) 2001 Deep Blue Solutions Ltd.
  *
- *  $Id: cpu.c,v 1.1 2004/07/22 19:48:59 joff Exp $
+ *  $Id: cpu.c,v 1.2 2004/08/04 01:25:39 joff Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
Index: arch/arm/mach-mx1ads/cpu.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mach-mx1ads/cpu.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mach-mx1ads/cpu.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/arm/mach-mx1ads/cpu.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -3,7 +3,7 @@
  *
  *  Copyright (C) 2001 Deep Blue Solutions Ltd.
  *
- *  $Id: cpu.c,v 1.1 2004/07/22 19:48:59 joff Exp $
+ *  $Id: cpu.c,v 1.2 2004/08/04 01:25:39 joff Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
Index: arch/arm/mach-sa1100/cpu-sa1110.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mach-sa1100/cpu-sa1110.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mach-sa1100/cpu-sa1110.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/arm/mach-sa1100/cpu-sa1110.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -3,7 +3,7 @@
  *
  *  Copyright (C) 2001 Russell King
  *
- *  $Id: cpu-sa1110.c,v 1.1 2004/07/22 19:48:59 joff Exp $
+ *  $Id: cpu-sa1110.c,v 1.2 2004/08/04 01:25:39 joff Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
Index: arch/arm/mach-sa1100/leds-system3.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mach-sa1100/leds-system3.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mach-sa1100/leds-system3.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/arm/mach-sa1100/leds-system3.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -5,15 +5,15 @@
  *
  * Original (leds-footbridge.c) by Russell King
  *
- * $Id: leds-system3.c,v 1.1 2004/07/22 19:48:59 joff Exp $
+ * $Id: leds-system3.c,v 1.2 2004/08/04 01:25:39 joff Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation.
  *
  * $Log: leds-system3.c,v $
- * Revision 1.1  2004/07/22 19:48:59  joff
- * Initial revision
+ * Revision 1.2  2004/08/04 01:25:39  joff
+ * merging 2.4.26-vrs1
  *
  * Revision 1.1.6.1  2001/12/04 15:19:26  seletz
  * - merged from linux_2_4_13_ac5_rmk2
Index: arch/arm/mach-sa1100/pm.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mach-sa1100/pm.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mach-sa1100/pm.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/arm/mach-sa1100/pm.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -21,6 +21,8 @@
  *
  * 2002-05-27:	Nicolas Pitre	Killed sleep.h and the kmalloced save array.
  * 				Storage is local on the stack now.
+ * 2003-06-25:  Jeff Corrall <jcorrall@mac.com>
+ *			Saved the GPIO levels for resume after sleep.
  */
 #include <linux/config.h>
 #include <linux/init.h>
@@ -70,13 +72,20 @@
 int pm_do_suspend(void)
 {
 	unsigned long sleep_save[SLEEP_SAVE_SIZE];
+	unsigned long sleep_save_gpsr;
+	unsigned long sleep_save_gpcr;
+	unsigned long delta;
 
 	cli();
 
 	leds_event(led_stop);
 
 	/* preserve current time */
-	RCNR = xtime.tv_sec;
+	delta = xtime.tv_sec - RCNR;
+
+	/* save the current state of the GPIO output pins */
+	sleep_save_gpsr = GPDR & GPLR;
+	sleep_save_gpcr = GPDR & ~GPLR;
 
 	/* save vital registers */
 	SAVE(OSCR);
@@ -121,6 +130,10 @@
 	printk(KERN_DEBUG "*** made it back from resume\n");
 #endif
 
+	/* restore GPIO output state before enabling the pins */
+	GPSR = sleep_save_gpsr;
+	GPCR = sleep_save_gpcr;
+
 	/* restore registers */
 	RESTORE(GPDR);
 	RESTORE(GRER);
@@ -151,7 +164,7 @@
 	RESTORE(ICMR);
 
 	/* restore current time */
-	xtime.tv_sec = RCNR;
+	xtime.tv_sec = RCNR + delta;
 
 	leds_event(led_start);
 
Index: arch/arm/mach-sa1100/system3.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mach-sa1100/system3.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mach-sa1100/system3.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/arm/mach-sa1100/system3.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -3,7 +3,7 @@
  *
  * Copyright (C) 2001 Stefan Eletzhofer <stefan.eletzhofer@eletztrick.de>
  *
- * $Id: system3.c,v 1.1 2004/07/22 19:48:59 joff Exp $
+ * $Id: system3.c,v 1.2 2004/08/04 01:25:39 joff Exp $
  *
  * This file contains all PT Sytsem 3 tweaks. Based on original work from
  * Nicolas Pitre's assabet fixes
@@ -13,8 +13,8 @@
  * published by the Free Software Foundation.
  *
  * $Log: system3.c,v $
- * Revision 1.1  2004/07/22 19:48:59  joff
- * Initial revision
+ * Revision 1.2  2004/08/04 01:25:39  joff
+ * merging 2.4.26-vrs1
  *
  * Revision 1.1.6.1  2001/12/04 17:28:06  seletz
  * - merged from previous branch
Index: arch/arm/mm/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/Makefile	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/Makefile	4 Aug 2004 01:25:39 -0000	1.2
@@ -39,6 +39,8 @@
 p-$(CONFIG_CPU_ARM925T)	+= proc-arm925.o
 p-$(CONFIG_CPU_ARM926T)	+= proc-arm926.o
 p-$(CONFIG_CPU_ARM1020)	+= proc-arm1020.o
+p-$(CONFIG_CPU_ARM1020E) += proc-arm1020E.o
+p-$(CONFIG_CPU_ARM1022)	+= proc-arm1022.o
 p-$(CONFIG_CPU_ARM1026)	+= proc-arm1026.o
 p-$(CONFIG_CPU_SA110)	+= proc-sa110.o
 p-$(CONFIG_CPU_SA1100)	+= proc-sa110.o
Index: arch/arm/mm/alignment.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/alignment.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/alignment.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/alignment.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -32,7 +32,7 @@
 
 /*
  * 32-bit misaligned trap handler (c) 1998 San Mehat (CCC) -July 1998
- * /proc/sys/debug/alignment, modified and integrated into
+ * /proc/cpu/alignment, modified and integrated into
  * Linux 2.1 by Russell King
  *
  * Speed optimisations and better fault handling by Russell King.
Index: arch/arm/mm/discontig.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/discontig.c,v
retrieving revision 1.1
retrieving revision 1.5
diff -u -r1.1 -r1.5
--- arch/arm/mm/discontig.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/discontig.c	27 Apr 2006 23:21:14 -0000	1.5
@@ -15,7 +15,7 @@
 #include <linux/init.h>
 #include <linux/bootmem.h>
 
-#if NR_NODES > 8
+#if NR_NODES > 24
 #error Fix Me Please
 #endif
 
@@ -46,6 +46,54 @@
 #if NR_NODES > 7
   { bdata: &node_bootmem_data[7] },
 #endif
+#if NR_NODES > 8
+  { bdata: &node_bootmem_data[8] },
+#endif
+#if NR_NODES > 9
+  { bdata: &node_bootmem_data[9] },
+#endif
+#if NR_NODES > 10 
+  { bdata: &node_bootmem_data[10] },
+#endif
+#if NR_NODES > 11 
+  { bdata: &node_bootmem_data[11] },
+#endif
+#if NR_NODES > 12 
+  { bdata: &node_bootmem_data[12] },
+#endif
+#if NR_NODES > 13 
+  { bdata: &node_bootmem_data[13] },
+#endif
+#if NR_NODES > 14 
+  { bdata: &node_bootmem_data[14] },
+#endif
+#if NR_NODES > 15
+  { bdata: &node_bootmem_data[15] },
+#endif
+#if NR_NODES > 16 
+  { bdata: &node_bootmem_data[16] },
+#endif
+#if NR_NODES > 17 
+  { bdata: &node_bootmem_data[17] },
+#endif
+#if NR_NODES > 18 
+  { bdata: &node_bootmem_data[18] },
+#endif
+#if NR_NODES > 19
+  { bdata: &node_bootmem_data[19] },
+#endif
+#if NR_NODES > 20 
+  { bdata: &node_bootmem_data[20] },
+#endif
+#if NR_NODES > 21 
+  { bdata: &node_bootmem_data[21] },
+#endif
+#if NR_NODES > 22 
+  { bdata: &node_bootmem_data[22] },
+#endif
+#if NR_NODES > 23
+  { bdata: &node_bootmem_data[23] },
+#endif
 };
 
 EXPORT_SYMBOL(discontig_node_data);
Index: arch/arm/mm/fault-armv.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/fault-armv.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/fault-armv.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/fault-armv.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -18,6 +18,7 @@
 
 #include <asm/pgalloc.h>
 #include <asm/pgtable.h>
+#include <asm/io.h>
 
 #include "fault.h"
 
@@ -100,6 +101,8 @@
 	do_translation_fault(addr, 0, regs);
 }
 
+static unsigned long shared_pte_mask = L_PTE_CACHEABLE;
+
 /*
  * We take the easy way out of this problem - we make the
  * PTE uncacheable.  However, we leave the write buffer on.
@@ -130,9 +133,9 @@
 	 * If this page isn't present, or is already setup to
 	 * fault (ie, is old), we can safely ignore any issues.
 	 */
-	if (pte_present(entry) && pte_val(entry) & L_PTE_CACHEABLE) {
+	if (pte_present(entry) && pte_val(entry) & shared_pte_mask) {
 		flush_cache_page(vma, address);
-		pte_val(entry) &= ~L_PTE_CACHEABLE;
+		pte_val(entry) &= ~shared_pte_mask;
 		set_pte(pte, entry);
 		flush_tlb_page(vma, address);
 		ret = 1;
@@ -157,9 +160,11 @@
 {
 	struct vm_area_struct *mpnt;
 	struct mm_struct *mm = vma->vm_mm;
-	unsigned long pgoff = (addr - vma->vm_start) >> PAGE_SHIFT;
+	unsigned long pgoff;
 	int aliases = 0;
 
+	pgoff = vma->vm_pgoff + ((addr - vma->vm_start) >> PAGE_SHIFT);
+
 	/*
 	 * If we have any shared mappings that are in the same mm
 	 * space, then we need to handle them specially to maintain
@@ -171,7 +176,7 @@
 
 		/*
 		 * If this VMA is not in our MM, we can ignore it.
-		 * Note that we intentionally don't mask out the VMA
+		 * Note that we intentionally mask out the VMA
 		 * that we are fixing up.
 		 */
 		if (mpnt->vm_mm != mm || mpnt == vma)
@@ -232,3 +237,75 @@
 		make_coherent(vma, addr, page, dirty);
 	}
 }
+
+/*
+ * Check whether the write buffer has physical address aliasing
+ * issues.  If it has, we need to avoid them for the case where
+ * we have several shared mappings of the same object in user
+ * space.
+ */
+static int __init check_writebuffer(unsigned long *p1, unsigned long *p2)
+{
+	register unsigned long zero = 0, one = 1, val;
+
+	mb();
+	*p1 = one;
+	mb();
+	*p2 = zero;
+	mb();
+	val = *p1;
+	mb();
+	return val != zero;
+}
+
+static inline void *map_page(struct page *page)
+{
+	void *map;
+
+	map = __ioremap(page_to_phys(page), PAGE_SIZE, L_PTE_BUFFERABLE);
+	if (map)
+		get_page(page);
+	return map;
+}
+
+static inline void unmap_page(void *map)
+{
+	iounmap(map);
+}
+
+void __init check_writebuffer_bugs(void)
+{
+	struct page *page;
+	const char *reason;
+	unsigned long v = 1;
+
+	printk(KERN_INFO "CPU: Testing write buffer: ");
+
+	page = alloc_page(GFP_KERNEL);
+	if (page) {
+		unsigned long *p1, *p2;
+
+		p1 = map_page(page);
+		p2 = map_page(page);
+
+		if (p1 && p2) {
+			v = check_writebuffer(p1, p2);
+			reason = "enabling work-around";
+		} else {
+			reason = "unable to map memory\n";
+		}
+
+		unmap_page(p1);
+		unmap_page(p2);
+		put_page(page);
+	} else {
+		reason = "unable to grab page\n";
+	}
+
+	if (v) {
+		printk("FAIL - %s\n", reason);
+		shared_pte_mask |= L_PTE_BUFFERABLE;
+	} else {
+		printk("pass\n");
+	}
+}
Index: arch/arm/mm/init.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/init.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/init.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/init.c	10 Jan 2005 22:45:19 -0000	1.2
@@ -615,11 +615,13 @@
 	high_memory = (void *)__va(meminfo.end);
 	max_mapnr   = virt_to_page(high_memory) - mem_map;
 
+#if 0
 	/*
 	 * We may have non-contiguous memory.
 	 */
 	if (meminfo.nr_banks != 1)
 		create_memmap_holes(&meminfo);
+#endif
 
 	/* this will put all unused low memory onto the freelists */
 	for (node = 0; node < numnodes; node++) {
Index: arch/arm/mm/ioremap.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/ioremap.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/ioremap.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/ioremap.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -144,7 +144,7 @@
 	 */
 	offset = phys_addr & ~PAGE_MASK;
 	phys_addr &= PAGE_MASK;
-	size = PAGE_ALIGN(last_addr) - phys_addr;
+	size = PAGE_ALIGN(last_addr + 1) - phys_addr;
 
 	/*
 	 * Ok, go for it..
Index: arch/arm/mm/mm-armo.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/mm-armo.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/mm-armo.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/mm-armo.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -104,6 +104,7 @@
 no_pte:
 	spin_unlock(&mm->page_table_lock);
 	pmd_free(new_pmd);
+	check_pgt_cache();
 	free_pgd_slow(new_pgd);
 	return NULL;
 
Index: arch/arm/mm/mm-armv.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/mm-armv.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/mm-armv.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/mm-armv.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -122,6 +122,7 @@
 no_pte:
 	spin_unlock(&mm->page_table_lock);
 	pmd_free(new_pmd);
+	check_pgt_cache();
 	free_pages((unsigned long)new_pgd, 2);
 	return NULL;
 
@@ -156,6 +157,7 @@
 	pmd_clear(pmd);
 	pte_free(pte);
 	pmd_free(pmd);
+	check_pgt_cache();
 free:
 	free_pages((unsigned long) pgd, 2);
 }
Index: arch/arm/mm/proc-arm1020.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/proc-arm1020.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/proc-arm1020.S	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/proc-arm1020.S	4 Aug 2004 01:25:39 -0000	1.2
@@ -743,12 +743,12 @@
 
 	.type	cpu_arch_name, #object
 cpu_arch_name:
-	.asciz	"armv4"
+	.asciz	"armv5t"
 	.size	cpu_arch_name, . - cpu_arch_name
 
 	.type	cpu_elf_name, #object
 cpu_elf_name:
-	.asciz	"v4"
+	.asciz	"v5"
 	.size	cpu_elf_name, . - cpu_elf_name
 	.align
 
@@ -756,9 +756,9 @@
 
 	.type	__arm1020_proc_info,#object
 __arm1020_proc_info:
-	.long	0x4100a200
-	.long	0xff00fff0
-	.long	0x00000c02			@ mmuflags
+	.long	0x4104a200			@ ARM 1020T (Architecture v5T)
+	.long	0xff0ffff0
+	.long	0x00000c0e			@ mmuflags
 	b	__arm1020_setup
 	.long	cpu_arch_name
 	.long	cpu_elf_name
Index: arch/arm/mm/proc-arm1026.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/proc-arm1026.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/proc-arm1026.S	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/proc-arm1026.S	4 Aug 2004 01:25:39 -0000	1.2
@@ -73,14 +73,17 @@
 	.align	5
 ENTRY(cpu_arm1026_data_abort)
 	mrc	p15, 0, r1, c5, c0, 0		@ get FSR
-	bic	r1, r1, #1 << 11 | 1 << 10
-	and	r2, r1, #0b1101			@ Check for translation error
-	teq	r1, r2, #0b1101
-	orrne	r1, r1, #1 << 11		@ set write bit
-
-	and	r3, r3, #255
 	mrc	p15, 0, r0, c6, c0, 0		@ get FAR
-
+	bic	r1, r1, #1 << 11 | 1 << 10	@ clear bits 11 and 10 of FSR
+	tst	r3, #PSR_J_BIT			@ Java?
+	orrne	r1, r1, #1 << 11		@ always assume write
+	movne	pc, lr
+	tst	r3, #PSR_T_BIT
+	ldrneh	r3, [r2]			@ read aborted thumb instruction
+	ldreq	r3, [r2]			@ read aborted ARM instruction
+	movne	r3, r3, lsl #(21 - 12)		@ move thumb bit 11 to ARM bit 20
+	tst	r3, #1 << 20			@ check write
+	orreq	r1, r1, #1 << 11
 	mov	pc, lr
 
 /*
@@ -256,7 +259,7 @@
  */
 	.align	5
 ENTRY(cpu_arm1026_dcache_invalidate_range)
-#ifndef CONFIG_CPU_ARM1026_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	tst	r0, #DCACHELINESIZE - 1
 	mcrne	p15, 0, r0, c7, c10, 1		@ clean D entry
 	tst	r1, #DCACHELINESIZE - 1
@@ -281,7 +284,7 @@
  */
 	.align	5
 ENTRY(cpu_arm1026_dcache_clean_range)
-#ifndef CONFIG_CPU_ARM1026_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	bic	r0, r0, #DCACHELINESIZE - 1
 	sub	r3, r1, r0
 	cmp	r3, #MAX_AREA_SIZE
@@ -311,7 +314,7 @@
  */
 	.align	5
 ENTRY(cpu_arm1026_dcache_clean_page)
-#ifndef CONFIG_CPU_ARM1026_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	mov	r1, #PAGESIZE
 1:	mcr	p15, 0, r0, c7, c10, 1		@ clean D entry
 	add	r0, r0, #DCACHELINESIZE
@@ -332,7 +335,7 @@
  */
 	.align	5
 ENTRY(cpu_arm1026_dcache_clean_entry)
-#ifndef CONFIG_CPU_ARM1026_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	mcr	p15, 0, r0, c7, c10, 1		@ clean D entry
 #endif
 	mcr	p15, 0, r0, c7, c10, 4		@ drain WB
@@ -475,7 +478,7 @@
 	biceq	r1, r1, #4			@ clear bufferable bit
 #endif
 	str	r1, [r0]
-#ifndef CONFIG_CPU_ARM1026_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	mcr	p15, 0, r0, c7, c10, 1		@ clean D entry
 #endif
 	mcr	p15, 0, r0, c7, c10, 4		@ drain WB
@@ -636,12 +639,12 @@
 
 	.type	cpu_arch_name, #object
 cpu_arch_name:
-	.asciz	"armv5EJ"
+	.asciz	"armv5tej"
 	.size	cpu_arch_name, . - cpu_arch_name
 
 	.type	cpu_elf_name, #object
 cpu_elf_name:
-	.asciz	"v5EJ"
+	.asciz	"v5"
 	.size	cpu_elf_name, . - cpu_elf_name
 	.align
 
Index: arch/arm/mm/proc-arm720.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/proc-arm720.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/proc-arm720.S	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/proc-arm720.S	4 Aug 2004 01:25:39 -0000	1.2
@@ -159,7 +159,7 @@
 ENTRY(cpu_arm720_data_abort)
 		tst	r3, #PSR_T_BIT
 		bne	.data_thumb_abort
-		ldr	r4, [r0]			@ read instruction causing problem
+		ldr	r4, [r2]			@ read instruction causing problem
 		and	r2, r4, #15 << 24
 		add	pc, pc, r2, lsr #22		@ Now branch to the relevent processing routine
 		movs	pc, lr
@@ -270,7 +270,7 @@
 		b	Ldata_saver7
 
 .data_thumb_abort:
-		ldrh	r4, [r0]			@ read instruction
+		ldrh	r4, [r2]			@ read instruction
 		tst	r4, #1 << 11
 		orrne	r4, r4, #1 << 20
 		and	r2, r4, #15 << 12
@@ -318,8 +318,8 @@
 		and	r0, r0, #15			@ number of regs to transfer
 		ldr	r7, [sp, #13 << 2]
 		tst	r4, #1 << 11
-		addne	r7, r7, r0, lsl #2		@ increment SP if PUSH
-		subeq	r7, r7, r0, lsr #2		@ decrement SP if POP
+		addeq	r7, r7, r0, lsl #2		@ increment SP if PUSH
+		subne	r7, r7, r0, lsl #2		@ decrement SP if POP
 		str	r7, [sp, #13 << 2]
 		b	Ldata_simple
 
@@ -336,7 +336,7 @@
 		and	r0, r0, #15			@ number of regs to transfer
 		and	r5, r4, #7 << 8
 		ldr	r7, [sp, r5, lsr #6]
-		sub	r7, r7, r0, lsr #2		@ always decrement
+		sub	r7, r7, r0, lsl #2		@ always decrement
 		str	r7, [sp, r5, lsr #6]
 		b	Ldata_simple
 
Index: arch/arm/mm/proc-arm920.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/proc-arm920.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/proc-arm920.S	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/proc-arm920.S	4 Aug 2004 01:25:39 -0000	1.2
@@ -256,14 +256,12 @@
  */
 	.align	5
 ENTRY(cpu_arm920_dcache_invalidate_range)
-#ifndef CONFIG_CPU_ARM920_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	tst	r0, #DCACHELINESIZE - 1
 	mcrne	p15, 0, r0, c7, c10, 1		@ clean D entry
-	mcrne   p15, 0, r2, c7, c10, 4		@ drain WB
 	tst	r1, #DCACHELINESIZE - 1
 	mcrne	p15, 0, r1, c7, c10, 1		@ clean D entry
-	mcrne   p15, 0, r2, c7, c10, 4		@ drain WB
-#endif
+#endif		@ clean D entry
 	bic	r0, r0, #DCACHELINESIZE - 1
 1:	mcr	p15, 0, r0, c7, c6, 1		@ invalidate D entry
 	add	r0, r0, #DCACHELINESIZE
@@ -283,18 +281,17 @@
  */
 	.align	5
 ENTRY(cpu_arm920_dcache_clean_range)
-	mov	r2, #0				@ For SBZs & invalidate_all_r2
-						@ But are SBZs mandatory?
-#ifndef CONFIG_CPU_ARM920_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	bic	r0, r0, #DCACHELINESIZE - 1
 	sub	r1, r1, r0
 	cmp	r1, #MAX_AREA_SIZE
+	mov	r2, #0
 	bhi	cpu_arm920_cache_clean_invalidate_all_r2
 
 1:	mcr	p15, 0, r0, c7, c10, 1		@ clean D entry
 	add	r0, r0, #DCACHELINESIZE
 	subs	r1, r1, #DCACHELINESIZE
-	bpl	1b
+	bcs	1b
 #endif
 	mcr	p15, 0, r2, c7, c10, 4		@ drain WB
 	mov	pc, lr
@@ -314,7 +311,7 @@
  */
 	.align	5
 ENTRY(cpu_arm920_dcache_clean_page)
-#ifndef CONFIG_CPU_ARM920_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	mov	r1, #PAGESIZE
 1:	mcr	p15, 0, r0, c7, c10, 1		@ clean D entry
 	add	r0, r0, #DCACHELINESIZE
@@ -323,7 +320,6 @@
 	subs	r1, r1, #2 * DCACHELINESIZE
 	bne	1b
 #endif
-	mcr	p15, 0, r1, c7, c10, 4		@ drain WB
 	mov	pc, lr
 
 /*
@@ -336,7 +332,7 @@
  */
 	.align	5
 ENTRY(cpu_arm920_dcache_clean_entry)
-#ifndef CONFIG_CPU_ARM920_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	mcr	p15, 0, r0, c7, c10, 1		@ clean D entry
 #endif
 	mcr	p15, 0, r0, c7, c10, 4		@ drain WB
@@ -368,12 +364,14 @@
 	bic	r0, r0, #ICACHELINESIZE - 1	@ Safety check
 	sub	r1, r1, r0
 	cmp	r1, #MAX_AREA_SIZE
-	bhi	cpu_arm920_cache_clean_invalidate_all
+	bhi	cpu_arm920_cache_clean_invalidate_all_r2
+
 1:	mcr	p15, 0, r0, c7, c5, 1		@ Clean I entry
 	mcr	p15, 0, r0, c7, c10, 1		@ Clean D entry
 	add	r0, r0, #ICACHELINESIZE
 	subs	r1, r1, #ICACHELINESIZE
-	bpl	1b
+	bcs	1b
+
 	mov	r0, #0
 	mcr	p15, 0, r0, c7, c10, 4		@ drain WB
 	mov	pc, lr
@@ -406,13 +404,17 @@
  */
 	.align	5
 ENTRY(cpu_arm920_tlb_invalidate_range)
-	bic	r0, r0, #(PAGESIZE - 1) & 0x00ff
-	bic	r0, r0, #(PAGESIZE - 1) & 0xff00
 	sub	r3, r1, r0
 	cmp	r3, #256 * PAGESIZE		@ arbitary, should be tuned
 	bhi	cpu_arm920_tlb_invalidate_all
+
 	mov	r3, #0
 	mcr	p15, 0, r3, c7, c10, 4		@ drain WB
+
+	mov	r3, #PAGESIZE
+	sub	r3, r3, #1
+	bic 	r0, r0, r3
+
 1:	mcr	p15, 0, r0, c8, c6, 1		@ invalidate D TLB entry
 	mcr	p15, 0, r0, c8, c5, 1		@ invalidate I TLB entry
 	add	r0, r0, #PAGESIZE
@@ -450,7 +452,7 @@
 ENTRY(cpu_arm920_set_pgd)
 	mov	ip, #0
 #ifdef CONFIG_CPU_DCACHE_WRITETHROUGH
-	mcr	p15, 0, ip, c7, c7, 0		@ invalidate I & D cache
+	mcr	p15, 0, ip, c7, c6, 0		@ invalidate D cache
 #else
 @ && 'Clean & Invalidate whole DCache'
 @ && Re-written to use Index Ops.
@@ -506,7 +508,7 @@
 	bic	r2, r2, #3
 	orr	r2, r2, #HPTE_TYPE_SMALL
 
-	tst	r1, #LPTE_USER			@ User or Exec?
+	tst	r1, #LPTE_USER			@ User?
 	orrne	r2, r2, #HPTE_AP_READ
 
 	tst	r1, #LPTE_WRITE | LPTE_DIRTY	@ Write and Dirty?
@@ -634,19 +636,13 @@
 	.size	cpu_elf_name, . - cpu_elf_name
 	.align
 
-#ifdef CONFIG_CPU_DCACHE_WRITETHROUGH
-#  define	MMU_FLAGS	0x00000c1a
-#else
-#  define	MMU_FLAGS	0x00000c1e
-#endif
-
 	.section ".proc.info", #alloc, #execinstr
 
 	.type	__arm920_proc_info,#object
 __arm920_proc_info:
 	.long	0x41009200
 	.long	0xff00fff0
-	.long	MMU_FLAGS			@ mmuflags
+	.long	0x00000c1e			@ mmuflags
 	b	__arm920_setup
 	.long	cpu_arch_name
 	.long	cpu_elf_name
Index: arch/arm/mm/proc-arm922.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/proc-arm922.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/proc-arm922.S	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/proc-arm922.S	4 Aug 2004 01:25:39 -0000	1.2
@@ -252,7 +252,7 @@
  */
 	.align	5
 ENTRY(cpu_arm922_dcache_invalidate_range)
-#ifndef CONFIG_CPU_ARM922_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	tst	r0, #DCACHELINESIZE - 1
 	mcrne	p15, 0, r0, c7, c10, 1		@ clean D entry
 	tst	r1, #DCACHELINESIZE - 1
@@ -278,7 +278,7 @@
  */
 	.align	5
 ENTRY(cpu_arm922_dcache_clean_range)
-#ifndef CONFIG_CPU_ARM922_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	bic	r0, r0, #DCACHELINESIZE - 1
 	sub	r1, r1, r0
 	cmp	r1, #MAX_AREA_SIZE
@@ -311,7 +311,7 @@
  */
 	.align	5
 ENTRY(cpu_arm922_dcache_clean_page)
-#ifndef CONFIG_CPU_ARM922_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	mov	r1, #PAGESIZE
 1:	mcr	p15, 0, r0, c7, c10, 1		@ clean D entry
 	add	r0, r0, #DCACHELINESIZE
@@ -332,7 +332,7 @@
  */
 	.align	5
 ENTRY(cpu_arm922_dcache_clean_entry)
-#ifndef CONFIG_CPU_ARM922_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	mcr	p15, 0, r0, c7, c10, 1		@ clean D entry
 #endif
 	mcr	p15, 0, r0, c7, c10, 4		@ drain WB
Index: arch/arm/mm/proc-arm926.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/proc-arm926.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/proc-arm926.S	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/proc-arm926.S	4 Aug 2004 01:25:39 -0000	1.2
@@ -259,7 +259,7 @@
  */
 	.align	5
 ENTRY(cpu_arm926_dcache_invalidate_range)
-#ifndef CONFIG_CPU_ARM926_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	tst	r0, #DCACHELINESIZE - 1
 	mcrne	p15, 0, r0, c7, c10, 1		@ clean D entry
 	tst	r1, #DCACHELINESIZE - 1
@@ -284,7 +284,7 @@
  */
 	.align	5
 ENTRY(cpu_arm926_dcache_clean_range)
-#ifndef CONFIG_CPU_ARM926_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	bic	r0, r0, #DCACHELINESIZE - 1
 	sub	r3, r1, r0
 	cmp	r3, #MAX_AREA_SIZE
@@ -314,7 +314,7 @@
  */
 	.align	5
 ENTRY(cpu_arm926_dcache_clean_page)
-#ifndef CONFIG_CPU_ARM926_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	mov	r1, #PAGESIZE
 1:	mcr	p15, 0, r0, c7, c10, 1		@ clean D entry
 	add	r0, r0, #DCACHELINESIZE
@@ -335,7 +335,7 @@
  */
 	.align	5
 ENTRY(cpu_arm926_dcache_clean_entry)
-#ifndef CONFIG_CPU_ARM926_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	mcr	p15, 0, r0, c7, c10, 1		@ clean D entry
 #endif
 	mcr	p15, 0, r0, c7, c10, 4		@ drain WB
@@ -478,7 +478,7 @@
 	biceq	r1, r1, #4			@ clear bufferable bit
 #endif
 	str	r1, [r0]
-#ifndef CONFIG_CPU_ARM926_WRITETHROUGH
+#ifndef CONFIG_CPU_DCACHE_WRITETHROUGH
 	mcr	p15, 0, r0, c7, c10, 1		@ clean D entry
 #endif
 	mcr	p15, 0, r0, c7, c10, 4		@ drain WB
Index: arch/arm/mm/proc-sa110.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mm/proc-sa110.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mm/proc-sa110.S	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/mm/proc-sa110.S	4 Aug 2004 01:25:39 -0000	1.2
@@ -86,12 +86,12 @@
 	.align	5
 ENTRY(cpu_sa110_data_abort)
 ENTRY(cpu_sa1100_data_abort)
-	mrc	p15, 0, r3, c5, c0, 0		@ get FSR
+	mrc	p15, 0, r1, c5, c0, 0		@ get FSR
 	mrc	p15, 0, r0, c6, c0, 0		@ get FAR
-	ldr	r1, [r2]			@ read aborted instruction
-	and	r3, r3, #255
-	tst	r1, r1, lsr #21			@ C = bit 20
-	sbc	r1, r1, r1			@ r1 = C - 1
+	ldr	r3, [r2]			@ read aborted instruction
+	bic	r1, r1, #1 << 11 | 1 << 10	@ clear bits 11 and 10 of FSR
+	tst	r3, #1 << 20			@ check write
+	orreq	r1, r1, #1 << 11
 	mov	pc, lr
 
 /*
